﻿namespace PS3Lib.IO
{
    using System;
    using System.IO;
    using PS3Lib;
	
	#region Credits
    /*Copyright © iMCSProduction 2013.
    Thanks to BuC-ShoTz for have contributed to this.
    Thanks to CraigChrist for his extension base for xbox.
    Visit www.NextGenUpdate.com if you're English.
    Visit www.FrenchModdingTeam.com if you're French.
    Follow me www.Twitter.com/iMCSx - www.Youtube.com/iMCSx*/
    #endregion

    public class PS3Stream : Stream
    {
        protected uint position;
        private readonly PS3API target;

        public PS3Stream(PS3API DEX)
        {
            this.target = DEX;
            this.position = 0x10000;
        }

        public override void Flush()
        {
        }

        public override int Read(byte[] buffer, int offset, int count)
        {
            uint num = 0;
            if (offset == 0)
            {
                this.target.GetMemory(this.position, buffer);
            }
            else
            {
                byte[] data = new byte[count];
                this.target.GetMemory(this.position, data);
                data.CopyTo(buffer, offset);
            }
            this.position += num;
            return (int) num;
        }

        public override long Seek(long offset, SeekOrigin origin)
        {
            switch (origin)
            {
                case SeekOrigin.Begin:
                    return (long) (this.position = (uint) offset);

                case SeekOrigin.Current:
                    return (long) (this.position += ((uint) offset));

                case SeekOrigin.End:
                    return (long) (this.position -= ((uint) offset));
            }
            throw new Exception("Invalid SeekOrigin.");
        }

        public override void SetLength(long value)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public override void Write(byte[] buffer, int offset, int count)
        {
            uint num = 0;
            this.target.SetMemory(this.position, buffer);
            this.position += num;
        }

        public override bool CanRead
        {
            get
            {
                return true;
            }
        }

        public override bool CanSeek
        {
            get
            {
                return true;
            }
        }

        public override bool CanWrite
        {
            get
            {
                return true;
            }
        }

        public override long Length
        {
            get
            {
                throw new Exception("The method or operation is not implemented.");
            }
        }

        public override long Position
        {
            get
            {
                return (long) this.position;
            }
            set
            {
                this.position = (uint) value;
            }
        }
    }
}

