﻿
using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Windows.Forms;
using System.Xml;

#region Credits
    /*Copyright © iMCSProduction 2013.
    Thanks to BuC-ShoTz for have contributed to this.
    Thanks to CraigChrist for his extension base for xbox.
    Visit www.NextGenUpdate.com if you're English.
    Visit www.FrenchModdingTeam.com if you're French.
    Follow me www.Twitter.com/iMCSx - www.Youtube.com/iMCSx*/
#endregion

namespace PS3Lib
{
    public class PS3API
    {
        public static int Target = 0xFF;
        public static bool AssemblyLoaded = true;
        public static byte[] myBuffer = new byte[0x20];

        public PS3API()
        {

        }
   
        public Extension Extension
        {
            get { return new Extension(); }
        }

        internal protected void DecompressDocumentation()
        {
            if (File.Exists(Application.StartupPath + @"\PS3Lib.XML"))
                return;
            StreamWriter Extract = new StreamWriter(Application.StartupPath + @"\PS3Lib.XML", true);
            Extract.WriteLine(Hex2Ascii(BitConverter.ToString(Properties.Resources.PS3Lib).Replace("-","")));
            Extract.Close();
        }

        public class SCECMD
        {
            /// <summary>Get the target status and return the string value.</summary>
            public string SNRESULT()
            {
                return Parameters.snresult;
            }

            public string GetTargetName()
            {
                if (Parameters.ConsoleName == null || Parameters.ConsoleName == String.Empty)
                {
                    PS3TMAPI.InitTargetComms();
                    PS3TMAPI.TargetInfo TargetInfo = new PS3TMAPI.TargetInfo();
                    TargetInfo.Flags = PS3TMAPI.TargetInfoFlag.TargetID;
                    TargetInfo.Target = PS3API.Target;
                    PS3TMAPI.GetTargetInfo(ref TargetInfo);
                    Parameters.ConsoleName = TargetInfo.Name;
                }
                return Parameters.ConsoleName;
            }

            /// <summary>Get the target status and return the string value.</summary>
            public string GetStatus()
            {
                if (PS3API.AssemblyLoaded)
                    return "NotConnected";
                Parameters.connectStatus = new PS3TMAPI.ConnectStatus();
                PS3TMAPI.GetConnectStatus(Target, out Parameters.connectStatus, out Parameters.usage);
                Parameters.Status = Parameters.connectStatus.ToString();
                return Parameters.Status;
            }

            /// <summary>Get the ProcessID by the current process.</summary>
            public uint ProcessID()
            {
                return Parameters.ProcessID;
            }

            /// <summary>Get an array of processID's.</summary>
            public uint[] ProcessIDs()
            {
                return Parameters.processIDs;
            }

            /// <summary>Get some details from your target.</summary>
            public PS3TMAPI.ConnectStatus DetailStatus()
            {
                return Parameters.connectStatus;
            }
        }

        public SCECMD SCE
        {
            get { return new SCECMD(); }
        }

        public class Parameters
        {
            public static string
                usage,
                info,
                snresult,
                Status,
                MemStatus,
                ConsoleName;
            public static uint
                ProcessID;
            public static uint[]
                processIDs;
            public static byte[]
                Retour;
            public static PS3TMAPI.ConnectStatus
                connectStatus;
        }

        /// <summary>Connect the default target and initialize the dll. Possible to put an int as arugment for determine which target to connect.</summary>
        public void ConnectDebug(int TargetIndex = 0)
        {
            if(AssemblyLoaded)
                GetPs3Api.PS3TMAPI_NET();
            AssemblyLoaded = false;
            Target = TargetIndex;
            PS3TMAPI.InitTargetComms();
            PS3TMAPI.Connect(TargetIndex, null);
        }

        /// <summary>Connect the target by is name.</summary>
        public void ConnectDebug(string TargetName)
        {
            if (AssemblyLoaded)
                GetPs3Api.PS3TMAPI_NET();
            AssemblyLoaded = false;
            PS3TMAPI.InitTargetComms();
            PS3TMAPI.GetTargetFromName(TargetName, out Target);
            PS3TMAPI.Connect(Target, null);
        }

        /// <summary>Attach and continue the current process from the target.</summary>
        public void ProcessAttach()
        {
            PS3TMAPI.GetProcessList(Target, out Parameters.processIDs);
            ulong uProcess = Parameters.processIDs[0];
            Parameters.ProcessID = Convert.ToUInt32(uProcess);
            PS3TMAPI.ProcessAttach(Target, PS3TMAPI.UnitType.PPU, Parameters.ProcessID);
            PS3TMAPI.ProcessContinue(Target, Parameters.ProcessID);
            Parameters.info = "The Process 0x" + Parameters.ProcessID.ToString("X8") + " Has Been Attached !";
        }

        /// <summary>Set memory to the target (byte[]).</summary>
        public void SetMemory(uint Address, byte[] Bytes)
        {
            PS3TMAPI.ProcessSetMemory(Target, PS3TMAPI.UnitType.PPU, Parameters.ProcessID, 0, Address, Bytes);
        }

        /// <summary>Set memory to the address (byte[]).</summary>
        public void SetMemory(uint Address, ulong value)
        {
            PS3TMAPI.ProcessSetMemory(Target, PS3TMAPI.UnitType.PPU, Parameters.ProcessID, 0, Address, BitConverter.GetBytes(value));
        }

        /// <summary>Set memory with value as string hexadecimal to the address (string).</summary>
        public void SetMemory(uint Address, string hexadecimal, EndianType Type = EndianType.BigEndian)
        {
            byte[] Entry = StringToByteArray(hexadecimal);
            byte[] Final;
            if (Type == EndianType.LittleEndian)
            {
                Array.Reverse(Entry);
                Final = Entry;
            }
            else
                Final = Entry;
            PS3TMAPI.ProcessSetMemory(Target, PS3TMAPI.UnitType.PPU, Parameters.ProcessID, 0, Address, Final);
        }

        /// <summary>Get memory from the address.</summary>
        public void GetMemory(uint Address, byte[] Bytes)
        {
            PS3TMAPI.ProcessGetMemory(Target, PS3TMAPI.UnitType.PPU, Parameters.ProcessID, 0, Address, ref Bytes);
        }

        /// <summary>Get a bytes array with the length input.</summary>
        public byte[] GetBytes(uint Address, uint lengthByte)
        {
            byte[] Longueur = new byte[lengthByte];
            PS3TMAPI.ProcessGetMemory(Target, PS3TMAPI.UnitType.PPU, Parameters.ProcessID, 0, Address, ref Longueur);
            return Longueur;
        }

        /// <summary>Get a string with the length input.</summary>
        public string GetString(uint Address, uint lengthString)
        {
            byte[] Longueur = new byte[lengthString];
            PS3TMAPI.ProcessGetMemory(Target, PS3TMAPI.UnitType.PPU, Parameters.ProcessID, 0, Address, ref Longueur);
            string StringResult = Hex2Ascii(ReplaceString(Longueur));
            return StringResult;
        }

        internal static string Hex2Ascii(string iMCSxString)
        {
            StringBuilder builder = new StringBuilder();
            for (int i = 0; i <= (iMCSxString.Length - 2); i += 2)
            {
                builder.Append(Convert.ToString(Convert.ToChar(int.Parse(iMCSxString.Substring(i, 2), NumberStyles.HexNumber))));
            }
            return builder.ToString();
        }

        internal static byte[] StringToByteArray(string hex)
        {
            string replace = hex.Replace("0x", "");
            string Stringz = replace.Insert(replace.Length - 1, "0");

            int Odd = replace.Length;
            bool Nombre;
            if (Odd % 2 == 0)
                Nombre = true;
            else
                Nombre = false;

            try
            {
                if (Nombre == true)
                {
                    return Enumerable.Range(0, replace.Length)
                 .Where(x => x % 2 == 0)
                 .Select(x => Convert.ToByte(replace.Substring(x, 2), 16))
                 .ToArray();
                }
                else
                {
                    return Enumerable.Range(0, replace.Length)
                 .Where(x => x % 2 == 0)
                 .Select(x => Convert.ToByte(Stringz.Substring(x, 2), 16))
                 .ToArray();
                }
            }
            catch { throw new System.ArgumentException("Value not possible.", "Byte Array"); }
        }

        internal static string ReplaceString(byte[] bytes)
        {
            string PSNString = BitConverter.ToString(bytes);
            PSNString = PSNString.Replace("00", string.Empty);
            PSNString = PSNString.Replace("-", string.Empty);
            PSNString = PSNString.Replace("^0", string.Empty);
            PSNString = PSNString.Replace("^1", string.Empty);
            PSNString = PSNString.Replace("^2", string.Empty);
            PSNString = PSNString.Replace("^3", string.Empty);
            PSNString = PSNString.Replace("^4", string.Empty);
            PSNString = PSNString.Replace("^5", string.Empty);
            PSNString = PSNString.Replace("^6", string.Empty);
            PSNString = PSNString.Replace("^7", string.Empty);
            PSNString = PSNString.Replace("^8", string.Empty);
            PSNString = PSNString.Replace("^9", string.Empty);
            return PSNString;
        }

        /// <summary>Reset target to XMB , Sometimes the target restart quickly.</summary>
        public void ResetToXMB(PS3TMAPI.ResetParameter resetParameter)
        {
            PS3TMAPI.Reset(Target, resetParameter);
        }
    }
}
