﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

#region Credits
/*Copyright © iMCSProduction 2013.
    Thanks to BuC-ShoTz for have contributed to this.
    Thanks to CraigChrist for his extension base for xbox.
    Visit www.NextGenUpdate.com if you're English.
    Visit www.FrenchModdingTeam.com if you're French.
    Follow me www.Twitter.com/iMCSx - www.Youtube.com/iMCSx*/
#endregion

// Original XDevKit++ by CraigChrist , Converted & Extended to PS3 by FM|T iMCSx.

namespace PS3Lib
{
    public class Extension
    {
        /// <summary>Read a signed byte.</summary>
        public sbyte ReadSByte(uint offset)
        {
            GetMemory(offset, PS3API.myBuffer);
            return (sbyte)PS3API.myBuffer[0];
        }

        /// <summary>Read a byte a check if his value. This return a bool according the byte detected.</summary>
        public bool ReadBool(uint offset)
        {
            GetMemory(offset, PS3API.myBuffer);
            return PS3API.myBuffer[0] != 0;
        }

        /// <summary>Read and return an integer 16 bits.</summary>
        public short ReadInt16(uint offset)
        {
            PS3API.myBuffer = GetBytes(offset, 2);
            Array.Reverse(PS3API.myBuffer, 0, 2);
            return BitConverter.ToInt16(PS3API.myBuffer, 0);
        }

        /// <summary>Read and return an integer 32 bits.</summary>
        public int ReadInt32(uint offset)
        {
            PS3API.myBuffer = GetBytes(offset, 4);
            Array.Reverse(PS3API.myBuffer, 0, 4);
            return BitConverter.ToInt32(PS3API.myBuffer, 0);
        }

        /// <summary>Read and return an integer 64 bits.</summary>
        public long ReadInt64(uint offset)
        {
            PS3API.myBuffer = GetBytes(offset, 8);
            Array.Reverse(PS3API.myBuffer, 0, 8);
            return BitConverter.ToInt64(PS3API.myBuffer, 0);
        }

        /// <summary>Read and return a byte.</summary>
        public byte ReadByte(uint offset)
        {
            PS3API.myBuffer = GetBytes(offset, 1);
            return PS3API.myBuffer[0];
        }

        /// <summary>Read a string with a length to the first byte equal to an value null (0x00).</summary>
        public byte[] ReadBytes(uint offset, int length)
        {
            PS3API.myBuffer = GetBytes(offset, (uint)length);
            return PS3API.myBuffer;
        }

        /// <summary>Read and return an unsigned integer 16 bits.</summary>
        public ushort ReadUInt16(uint offset)
        {
            PS3API.myBuffer = GetBytes(offset, 2);
            Array.Reverse(PS3API.myBuffer, 0, 2);
            return BitConverter.ToUInt16(PS3API.myBuffer, 0);
        }

        /// <summary>Read and return an unsigned integer 32 bits.</summary>
        public uint ReadUInt32(uint offset)
        {
            PS3API.myBuffer = GetBytes(offset, 4);
            Array.Reverse(PS3API.myBuffer, 0, 4);
            return BitConverter.ToUInt32(PS3API.myBuffer, 0);
        }

        /// <summary>Read and return an unsigned integer 64 bits.</summary>
        public ulong ReadUInt64(uint offset)
        {
            PS3API.myBuffer = GetBytes(offset, 8);
            Array.Reverse(PS3API.myBuffer, 0, 8);
            return BitConverter.ToUInt64(PS3API.myBuffer, 0);
        }

        /// <summary>Read and return a Float.</summary>
        public float ReadFloat(uint offset)
        {
            PS3API.myBuffer = GetBytes(offset, 4);
            Array.Reverse(PS3API.myBuffer, 0, 4);
            return BitConverter.ToSingle(PS3API.myBuffer, 0);
        }

        /// <summary>Read a string and stop only when a byte null is detected (0x00).</summary>
        public string ReadString(uint offset)
        {
            byte[] Reader = new byte[1]; uint i = 0;
            List<byte> StringBuilder = new List<byte>();
            while (true)
            {
                GetMemory(offset + i, Reader);
                if (Reader[0] == 0x00)
                    break;
                else
                    StringBuilder.Add(Reader[0]);
                i++;
            }
            System.Text.UTF8Encoding Encode = new System.Text.UTF8Encoding();
            return Encode.GetString(StringBuilder.ToArray());
        }

        /// <summary>Write a signed byte.</summary>
        public void WriteSByte(uint offset, sbyte input)
        {
            byte[] buff = new byte[1];
            buff[0] = (byte)input;
            SetMemory(offset, buff);
        }

        /// <summary>Write a boolean.</summary>
        public void WriteBool(uint offset, bool input)
        {
            byte[] buff = new byte[1];
            buff[0] = input ? (byte)1 : (byte)0;
            SetMemory(offset, buff);
        }

        /// <summary>Write an interger 16 bits.</summary>
        public void WriteInt16(uint offset, short input)
        {
            byte[] buff = new byte[2];
            BitConverter.GetBytes(input).CopyTo(buff, 0);
            Array.Reverse(buff, 0, 2);
            SetMemory(offset, buff);
        }

        /// <summary>Write an integer 32 bits.</summary>
        public void WriteInt32(uint offset, int input)
        {
            byte[] buff = new byte[4];
            BitConverter.GetBytes(input).CopyTo(buff, 0);
            Array.Reverse(buff, 0, 4);
            SetMemory(offset, buff);
        }

        /// <summary>Write an integer 64 bits.</summary>
        public void WriteInt64(uint offset, long input)
        {
            byte[] buff = new byte[8];
            BitConverter.GetBytes(input).CopyTo(buff, 0);
            Array.Reverse(buff, 0, 8);
            SetMemory(offset, buff);
        }

        /// <summary>Write a byte.</summary>
        public void WriteByte(uint offset, byte input)
        {
            byte[] buff = new byte[1];
            buff[0] = input;
            SetMemory(offset, PS3API.myBuffer);
        }

        /// <summary>Write a byte array.</summary>
        public void WriteBytes(uint offset, byte[] input)
        {
            byte[] buff = input;
            SetMemory(offset, buff);
        }

        /// <summary>Write a string.</summary>
        public void WriteString(uint offset, string input)
        {
            byte[] buff = Encoding.UTF8.GetBytes(input);
            Array.Resize(ref buff, buff.Length + 1);
            SetMemory(offset, buff);
        }

        /// <summary>Write an unsigned integer 16 bits.</summary>
        public void WriteUInt16(uint offset, ushort input)
        {
            byte[] buff = new byte[2];
            BitConverter.GetBytes(input).CopyTo(buff, 0);
            Array.Reverse(buff, 0, 2);
            SetMemory(offset, buff);
        }

        /// <summary>Write an unsigned integer 32 bits.</summary>
        public void WriteUInt32(uint offset, uint input)
        {
            byte[] buff = new byte[4];
            BitConverter.GetBytes(input).CopyTo(buff, 0);
            Array.Reverse(buff, 0, 4);
            SetMemory(offset, buff);
        }

        /// <summary>Write an unsigned integer 64 bits.</summary>
        public void WriteUInt64(uint offset, ulong input)
        {
            byte[] buff = new byte[8];
            BitConverter.GetBytes(input).CopyTo(buff, 0);
            Array.Reverse(PS3API.myBuffer, 0, 8);
            SetMemory(offset, buff);
        }

        /// <summary>Write a Float.</summary>
        public void WriteFloat(uint offset, float input)
        {
            byte[] buff = new byte[4];
            BitConverter.GetBytes(input).CopyTo(buff, 0);
            Array.Reverse(buff, 0, 4);
            SetMemory(offset, buff);
        }

        private void SetMemory(uint Address, byte[] Bytes)
        {
            PS3TMAPI.ProcessSetMemory(PS3API.Target, PS3TMAPI.UnitType.PPU, PS3Lib.PS3API.Parameters.ProcessID, 0, Address, Bytes);
        }

        private void GetMemory(uint Address, byte[] Bytes)
        {
            PS3TMAPI.ProcessGetMemory(PS3API.Target, PS3TMAPI.UnitType.PPU, PS3Lib.PS3API.Parameters.ProcessID, 0, Address, ref Bytes);
        }

        private byte[] GetBytes(uint Address, uint lengthByte)
        {
            byte[] Longueur = new byte[lengthByte];
            PS3TMAPI.ProcessGetMemory(PS3API.Target, PS3TMAPI.UnitType.PPU, PS3Lib.PS3API.Parameters.ProcessID, 0, Address, ref Longueur);
            return Longueur;
        }
    }
}